package com.tzld.piaoquan.risk.control.controller;

import com.alibaba.fastjson.JSON;
import com.tzld.piaoquan.risk.control.common.annotation.UnAuth;
import com.tzld.piaoquan.risk.control.common.base.CommonResponse;
import com.tzld.piaoquan.risk.control.config.QywxConfig;
import com.tzld.piaoquan.risk.control.model.qywx.QwLoginCheckCode;
import com.tzld.piaoquan.risk.control.model.qywx.RiskUserDelResult;
import com.tzld.piaoquan.risk.control.model.qywx.RiskUserInfo;
import com.tzld.piaoquan.risk.control.service.impl.RiskUserHandleService;
import lombok.extern.slf4j.Slf4j;
import org.apache.rocketmq.shaded.org.slf4j.MDC;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.UUID;

@RestController
@RequestMapping("/qw")
@Slf4j
public class ReceiveRiskInfoController {
    @Autowired
    private QywxConfig qywxConfig; // 注入配置类
    @Autowired
    private RiskUserHandleService riskUserHandleService;

    /**
     * 接收风控用户信息
     * @param userInfo 风控用户信息
     * @return CommonResponse
     */
    @UnAuth
    @PostMapping("/push/riskuser")
    public CommonResponse<RiskUserDelResult> receiveRiskUser(@RequestBody String rawJson) {
//        String traceId = UUID.randomUUID().toString();
//        MDC.put("traceId", traceId);

        log.info("receiveRiskUser, raw json: {}", rawJson);
        RiskUserInfo userInfo = JSON.parseObject(rawJson, RiskUserInfo.class); // 手动解析
        int ret =  riskUserHandleService.handleRiskUser(userInfo);
        // 创建数据对象并设置 is_del 值
        RiskUserDelResult result = new RiskUserDelResult();
        result.setIsDel(ret); // 成功为1，失败为0
//        MDC.clear();
        return CommonResponse.success(result);
    }
}
